// var Router = Backbone.Router.extend({
//   routes: {
//     '': 'index',
//     'business/:title': 'viewBusiness'
//   },
//   index: function() {
//     console.log('app running');
//   },
//   viewBusiness: function(title) {
//     var subpageView = new SubPageView(title);
//     subpageView.render().el;
//     $('body').scrollTop(0);
//   }
// });

App.Router = Backbone.Router.extend({
  routes: {
    '': 'index',
    'search': 'viewSearch',
    'location': 'viewLocation',
    'business/:title': 'viewBusiness',
    'detail/:id': 'viewDetail',
    'schedule': 'viewSchedule',
    'sponsor': 'viewSponsor'
  },
  index: function() {
    console.log('start app');
    $("#nav_img").attr('src','img/menu_nav.png');
    $("#judul_lbl").html("Bandung Great Sale 2016");
    $("#judul_lbl").css({"text-align":"center"});
    $("#find_nav").attr('style','visibility: visible');
    $("#lokasi_lbl").hide();
    $("#map").hide();
    $("#maplistcont").hide();
    $("#searchbox").hide();
    $("#bisnis_lbl").show();
    $("#foundloc_lbl").hide();
    $("#found_lbl").hide();
    $("#densecardcont").show();
    $('#cardcont').remove();
    $("#listcont").show();
    $("#sponsorcont").hide();
    $("#detailcont").hide();
    $("#nav_img").attr('class', 'menunav');
    //side nav
    $("#nav_img").off('click');
    $('.menunav').click(function(event) {
        /* Act on the event */
        var thisis = $(this).attr('class');
        if (thisis == 'menunav') {
           $('.side-nav').addClass('side-nav--visible');
        }
    });

    $('.side-nav').click(function(event) {
        /* Act on the event */
        $('.side-nav').removeClass('side-nav--visible');
    });

    $('.side-nav-container').click(function(event) {
        /* Act on the event */
        event.stopPropagation();
    });

    // set posisi scroll top
    $('body').scrollTop(0);
  },
  viewSearch: function() {
    $("#nav_img").attr('src','img/back_nav.png');
    $("#nav_img").attr('class', 'backnav');
    $("#lokasi_lbl").hide();
    $("#find_nav").attr('style','visibility: hidden');
    $("#map").hide();
    $("#maplistcont").hide();
    $("#judul_lbl").html("Search");
    $("#judul_lbl").css({"text-align":"left"});
    $("#bisnis_lbl").hide();
    $("#foundloc_lbl").hide();
    $("#searchbox").show();
    $("#found_lbl").show();
    $("#densecardcont").hide();
    $('#cardcont').remove();
    $("#listcont").show();
    $("#sponsorcont").hide();
    $("#detailcont").hide();
    $('body').scrollTop(0);
    $("#nav_img").off('click');
    $('#searchtxt').focus();
    $('#searchtxt').keyup(function(event) {
      /* Act on the event */
      var data = merchants.toJSON();
      var cariini = $('#searchtxt').val();

      var count = 0;
      
      $('#cardcont').remove();
      var displayFound = "<ul id='cardcont'>";
      var cariini = $('#searchtxt').val();
      if (cariini.length > 2) {
        $.each(data, function(index, val) {
           /* iterate through array or object */
          var label = val.nama;
          var re = new RegExp(cariini,"gi");
          var rdata = re.test(label);                
          if (rdata == true) {
            displayFound += '<li class="card" data-id="'+val.id+'"><h2>'+decodeHtml(label)+'</h2><div class="address">'+val.alamat+'</div><div class="detail">'+val.bidangusaha+'</div></li>';
            count++;
          };
        });
        displayFound += "</ul>";
        $('#listcont').append(displayFound);
      }
      $('#found_lbl').html("Found: "+count);

      $('.card').click(function(event) {
        /* Act on the event */
        prevURL = 'search';
        var id = $(this).data('id');
        var urlPath = 'detail/'+id;
        router.navigate(urlPath, {trigger: true});
      });
    });

    $(".backnav").on('click', function(event) {
      event.preventDefault();
      /* Act on the event */
      var thisis = $(this).attr('class');
        if (thisis == 'backnav') {
          //$('#cardcont').remove();
          router.navigate('', {trigger: true});
        }
    });
  },  
  viewBusiness: function(title) {
    $("#nav_img").attr('src','img/back_nav.png');
    $("#nav_img").attr('class', 'backnav');
    $("#lokasi_lbl").hide();
    $("#find_nav").attr('style','visibility: hidden');
    $("#map").hide();
    $("#maplistcont").hide();
    $("#judul_lbl").html(title);
    $("#judul_lbl").css({"text-align":"left"});
    $("#bisnis_lbl").hide();
    $("#searchbox").hide();
    $("#foundloc_lbl").hide();
    $("#densecardcont").hide();
    $('#cardcont').remove();
    $("#listcont").show();
    $("#sponsorcont").hide();
    $("#detailcont").hide();
    $('body').scrollTop(0);
    $("#nav_img").off('click');
    $(".backnav").on('click', function(event) {
      event.preventDefault();
      /* Act on the event */
      var thisis = $(this).attr('class');
        if (thisis == 'backnav') {
          $('#cardcont').remove();
          router.navigate('', {trigger: true});
        }
    });

    var subpage = new App.Views.Subpage(title);
    subpage.render().el;

    $('.card').click(function(event) {
      /* Act on the event */
      prevURL = 'business/#'+title;
      var id = $(this).data('id');
      var urlPath = 'detail/'+id;
      router.navigate(urlPath, {trigger: true});
    });
  },
  viewDetail: function(id) {
    console.log(id);
    $("#nav_img").attr('src','img/back_nav.png');
    $("#nav_img").attr('class', 'backnav');
    $("#lokasi_lbl").hide();
    $("#find_nav").attr('style','visibility: hidden');
    $("#map").hide();
    $("#maplistcont").hide();
    $("#judul_lbl").html("Detail");
    $("#judul_lbl").css({"text-align":"left"});
    $("#bisnis_lbl").hide();
    $("#searchbox").hide();
    $("#foundloc_lbl").hide();
    $("#found_lbl").hide();
    $("#densecardcont").hide();
    $("#listcont").hide();
    $("#sponsorcont").hide();
    $("#detailcont").show();
    $('body').scrollTop(0);
    $("#nav_img").off('click');

    $(".backnav").on('click', function(event) {
      event.preventDefault();
      /* Act on the event */
      var thisis = $(this).attr('class');
        if (thisis == 'backnav') {
          //$('#cardcont').remove();
          //router.navigate(prevURL, {trigger: true});
          window.history.back();
        }
    });

    $.each(merchants.models, function(index, val) {
       /* iterate through array or object */
       var idx = val.get('id');
       if (id == idx) {
        var nama = val.get('nama');
        var alamat = val.get('alamat');
        var lat = val.get('lat');
        var lng = val.get('lng');
        var sale = val.get('sale');
        var sale_note = val.get('sale_note');
        var deskripsi = val.get('deskripsi');

        $('#detail_nama').text(decodeHtml(nama));
        $('#detail_alamat').text(alamat);
        $('#detail_promo').text(sale);
        $('#detail_promonote').text(decodeHtml(sale_note));
        $('#detail_deskripsi').html(decodeHtml(deskripsi));

        var p2 = new google.maps.LatLng(lat, lng);

        $('#detail_range').click(function(event) {
          /* Act on the event */
          var urlPath = "http://maps.google.com/maps?daddr="+p2+"&amp;ll=";
          alert(urlPath);
          window.open(urlPath, '_system');
        });

        $('#editinfo').click(function(event) {
          var urlPath = 'http://mybandung.id/event/editparticipant/login.php?eventid=3&participantid='+id;
          alert(urlPath);
          window.open(urlPath, '_system');
        });

        
        MyMap.getGPS(p2);
       }
    });

    
  },
  viewLocation: function() {
    $("#nav_img").attr('src','img/back_nav.png');
    $("#nav_img").attr('class', 'backnav');
    $("#lokasi_lbl").hide();
    $("#find_nav").attr('style','visibility: hidden');
    $("#map").show();
    $("#maplistcont").show();
    $("#judul_lbl").html("Lokasi");
    $("#judul_lbl").css({"text-align":"left"});
    $("#bisnis_lbl").hide();
    $("#searchbox").hide();
    $("#foundloc_lbl").hide();
    $("#found_lbl").hide();
    $("#densecardcont").hide();
    $('#cardcont').remove();
    $("#listcont").hide();
    $("#sponsorcont").hide();
    $("#detailcont").hide();
    $('body').scrollTop(0);
    $("#nav_img").off('click');

    MyMap.init();


    $(".backnav").on('click', function(event) {
      event.preventDefault();
      /* Act on the event */
      var thisis = $(this).attr('class');
        if (thisis == 'backnav') {
          $('#cardcont').remove();
          navigator.geolocation.clearWatch(mypos);
          router.navigate('', {trigger: true});
        }
    });
  },
  viewSchedule: function() {
    $("#nav_img").attr('src','img/back_nav.png');
    $("#nav_img").attr('class', 'backnav');
    $("#lokasi_lbl").hide();
    $("#find_nav").attr('style','visibility: hidden');
    $("#map").hide();
    $("#maplistcont").hide();
    $("#judul_lbl").html("Kalendar Program");
    $("#judul_lbl").css({"text-align":"left"});
    $("#bisnis_lbl").hide();
    $("#searchbox").hide();
    $("#foundloc_lbl").hide();
    $("#found_lbl").hide();
    $("#densecardcont").hide();
    $('#cardcont').remove();
    $("#listcont").show();
    $("#sponsorcont").hide();
    $("#detailcont").hide();
    $('body').scrollTop(0);
    $("#nav_img").off('click');

    schedules = scheduleCollection;

    $.each(schedules.models, function(index, el) {
      var nilai = el.toJSON();
      if (arrTglRaw.indexOf(nilai.tgl) == -1) {
        arrTglRaw.push(nilai.tgl);
        var d = new Date(nilai.tgl);
        var tanggal = d.getDate() +" "+ month[d.getMonth()];
        var hari = weekday[d.getDay()];
        if (nilai.hari !== "") { hari = hari+" ("+nilai.hari+")"; }
        arrTgl.push({id: nilai.tgl, tgl: tanggal, hari: hari});
      }
    });

    tgl = new App.Models.Tgl;
    kalendar = new App.Collections.Tgl(arrTgl);
    displayKalender = new App.Views.Kalendar({ collection: kalendar });
    

    $(".backnav").on('click', function(event) {
      event.preventDefault();
      /* Act on the event */
      var thisis = $(this).attr('class');
        if (thisis == 'backnav') {
          $('#cardcont').remove();
          router.navigate('', {trigger: true});
        }
    });
  },
  viewSponsor: function() {
    $("#nav_img").attr('src','img/back_nav.png');
    $("#nav_img").attr('class', 'backnav');
    $("#lokasi_lbl").hide();
    $("#find_nav").attr('style','visibility: hidden');
    $("#map").hide();
    $("#maplistcont").hide();
    $("#judul_lbl").html("Sponsor &amp; Partner");
    $("#judul_lbl").css({"text-align":"left"});
    $("#bisnis_lbl").hide();
    $("#searchbox").hide();
    $("#foundloc_lbl").hide();
    $("#found_lbl").hide();
    $("#densecardcont").hide();
    $("#listcont").hide();
    $("#sponsorcont").show();
    $("#detailcont").hide();
    $('body').scrollTop(0);
    $("#nav_img").off('click');
    var sponsorDisplay = new App.Views.SponsorPartner;
    $("#sponsorcont").html(sponsorDisplay.el);
    $(".backnav").on('click', function(event) {
      event.preventDefault();
      /* Act on the event */
      var thisis = $(this).attr('class');
        if (thisis == 'backnav') {
          //$('#cardcont').remove();
          router.navigate('', {trigger: true});
        }
    });
  }
})
