//view map
App.Views.Client_locView = Backbone.View.extend({
  initialize: function() {
    getLocation();
  },
  render: function() {
    this.model.toJSON();
    return this;
  }
});

//search views
App.Views.Search = Backbone.View.extend({
  el: ".bar-top",
  events: {
    "click #find_nav": "showpencarian"
  },
  showpencarian: function() {
    console.log("cari");
    router.navigate('search', {trigger: true});
  },
  render: function() {
    return this;
  }
});

//view sidenav menu
App.Views.Sidenav = Backbone.View.extend({
  el: '#sidenavlistcont',
  events: {
    "click #lokasilink" : "showlokasi",
    "click #kategorilink" : "showkategori",
    "click #kalendarlink" : "showkalendar",
    "click #sponsorlink" : "showsponsor",
    "click #daftarlink" : "showdaftar",
    "click #bantuanlink" : "showbantuan"
  },
  showlokasi: function () {
    console.log("lokasi");
    $('.side-nav').removeClass('side-nav--visible');
    router.navigate('location', {trigger: true});
  },
  showkategori: function () {
    console.log("kategori");
    $('.side-nav').removeClass('side-nav--visible');
    router.navigate('', {trigger: true});
  },
  showkalendar: function () {
    console.log("kalendar");
    $('.side-nav').removeClass('side-nav--visible');
    router.navigate('schedule', {trigger: true});
  },
  showsponsor: function () {
    console.log("sponsor");
    $('.side-nav').removeClass('side-nav--visible');
    router.navigate('sponsor', {trigger: true});
  },
  showdaftar: function () {
    console.log("daftar");
    $('.side-nav').removeClass('side-nav--visible');
    window.open('http://mybandung.id/event/registerparticipant.php?eventid=3', '_system');
  },
  showbantuan: function () {
    console.log("bantuan");
    $('.side-nav').removeClass('side-nav--visible');
  },
  render: function () {
    return this;
  }
});

//view merchant
App.Views.MerchantView = Backbone.View.extend({
  tagName: 'li',
  className: 'cards',
  template: _.template("<div><h2><%= nama %></h2><div class=\"address\"><%= alamat %></div><div><%= sale %><br/><%= sale_note %></div></div>"),
  render: function() {
    this.$el.html(this.template(this.model.toJSON()));
    return this;
  }
});

//view business
App.Views.Business = Backbone.View.extend({
  tagName: 'li',
  className: 'densecard',
  template: _.template("<div><h2><%= bidangusaha %></h2></div>"),
  events: {
    'click div': 'showlist'
  },
  showlist: function() {
    vent.trigger('business:selected', this.model);
  },
  render: function() {
    this.$el.html(this.template(this.model.toJSON()));
    return this;
  }
});

//view business collection
App.Views.BusinessCollection = Backbone.View.extend({
  tagName: 'ul',
  id: 'densecardcont',
  render: function() {
    this.collection.each(function(business){
      var businessView = new App.Views.Business({ model: business });
      this.$el.append(businessView.render().el);
    }, this);
    return this;
  }
});

function displayBusiness () {
  var bisnis = new App.Collections.Business(arrBusiness);
  var bisnisView = new App.Views.BusinessCollection({ collection: bisnis });
  $("#listcont").append(bisnisView.render().el);
}

//view sale
App.Views.Sale = Backbone.View.extend({
  tagName: 'li',
  className: 'group',
  template: _.template("<div class=\"subjudul\"><%= sale %></div><ul id=\"<%= saleid %>\" class=\"groupcont\"></ul>"),
  render: function() {
    this.$el.html(this.template(this.model.toJSON()));
    return this;
  }
});

//view sale collection
App.Views.SaleCollection = Backbone.View.extend({
  tagName: 'ul',
  id: 'cardcont',
  render: function() {
    this.collection.each(function(sale){
      var saleView = new App.Views.Sale({ model: sale });
      this.$el.append(saleView.render().el);
    }, this);
    return this;
  }
});

//view subpage
var arrSale = [];
var arrSales = [];
var arrSaleMerchant = [];
var arrSaleRaw = ['Up to 90%','Up to 80%','Up to 70%','Up to 60%','Up to 50%','Up to 40%','Up to 30%','Up to 20%','Up to 10%','All items 90%','All items 80%','All items 70%','All items 60%','All items 50%','All items 40%','All items 30%','All items 20%','All items 10%','Buy 1 get 1 free','Buy 1 get 2 free','Buy 1 get 3 free','Buy 2 get 1 free','Buy 2 get 2 free','Buy 2 get 3 free','Buy 3 get 1 free','Buy 3 get 2 free','Buy 3 get 3 free','Free souvenir','Free voucher belanja','Free voucher makan','Lainnya'];

App.Views.Subpage = Backbone.View.extend({
  initialize: function(xbidangusaha) {
    arrSale = [];
    arrSales = [];
    arrSaleMerchant = [];
    $.each(merchants.models, function(index, value) {
      var nilai = value.toJSON();
      if (arrSale.indexOf(nilai.sale) == -1 && nilai.bidangusaha == xbidangusaha) {
        arrSale.push(nilai.sale);
      }
      if (nilai.bidangusaha == xbidangusaha) {
        arrSaleMerchant.push(index);
      }
    });
  },
  render: function() {
    $.each(arrSaleRaw, function(index, value) {
      if (arrSale.indexOf(value.toLowerCase()) > -1) {
        arrSales.push({sale: value, saleid: value.toLowerCase()});
      }
    });
    //ambil data sale
    saleCollection = new App.Collections.Sale(arrSales);
    salesView = new App.Views.SaleCollection({ collection: saleCollection });
    $("#listcont").append(salesView.render().el);
    $.each(arrSaleMerchant, function(index, el) {
      var nilai = merchants.models[el].attributes;
      var elid = document.getElementById(nilai.sale);
      $(elid).append('<li class="card" data-id="'+nilai.id+'"><h2>'+decodeHtml(nilai.nama)+'</h2><div class="address">'+nilai.alamat+'</div></li>');
    });
    return this;
  }
});

//view detail
App.Views.Detail = Backbone.View.extend({
  
});

//view sponsor and partner
App.Views.SponsorPartner = Backbone.View.extend({
  initialize: function() {
    this.render();
  },
  render: function() {
    this.$el.html('<div id="sponsor_lbl" class="subjudul" style="">Sponsor</div><img class="sponsorpanel" src= "img/sponsor.jpg"/><div id="partner_lbl" class="subjudul" style="">Partner</div><img class="partnerpanel" src= "img/partner.jpg"/>');
    return this;
  }
});

//tampilan group tanggal
App.Views.ScheduleDate = Backbone.View.extend({
  tagName: 'li',
  className: 'group',
  template: _.template("<div class=\"subjudul\"><%= hari %>, <%= tgl %></div><ul id=\"<%= id %>\" class=\"groupcont\"></ul>"),
  initialize: function() {
    this.render();
  },
  render: function() {
    this.$el.html(this.template(this.model.toJSON()));
    return this;
  }
});

//tampilan container group tanggal
App.Views.Kalendar = Backbone.View.extend({
  tagName: 'ul',
  id: 'cardcont',
  initialize: function() {
    this.render();
  },
  render: function() {
    this.collection.each(function(tgl){
      var dateView = new App.Views.ScheduleDate({ model: tgl });
      this.$el.append(dateView.render().el);
    }, this);
    $("#listcont").append(this.el);
    $.each(arrTgl, function(index, el) {
      var nilai = el;
      var elid = document.getElementById(nilai.id);
      $.each(schedules.models, function(index, el) {
        var data = el.toJSON();
        if (data.tgl == nilai.id) {
          $(elid).append("<li class=\"card\"><h2>"+decodeHtml(data.nama)+"</h2><div class=\"address\">"+data.venue+"</div><div class=\"detail\">"+data.detail+"</div></li>");
        }
      });
    });
    var d = new Date();
    var bln = (parseInt(d.getMonth()) + 1) + "";
    if (bln.length < 2) {
      bln  = "0"+bln;
    }
    var today = d.getFullYear()+"-"+bln+"-"+d.getDate();
    var targetel = $('.subjudul');
    // $.each(targetel,function(index, el) {
    //   var todaytext = "";
    //   console.log("id:"+arrTgl[index].id+",idx:"+index);
    //   if (arrTgl[index].id == today) {
    //     todaytext = "<span class=\"today\">Hari Ini</span>";
    //     $(this).append(todaytext);
    //     return false;
    //   }
    // });
    return this;
  }
});

//view schedule
App.Views.Schedule = Backbone.View.extend({
  render: function() {
    return this;
  }
});

